package com.unis.qyzg.client;

import com.unis.common.utils.ResponseWrapper;
import com.unis.qyzg.common.vo.QyzgQyzgxxVO;
import com.unis.qyzg.common.vo.QyzgZgsqVO;
import com.unis.qyzg.common.vo.UpdateSqztVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

/**
 *  企业资格管理
 * @ClassName: CompanyClient
 * @Description: COMPANY接口服务调用
 * @author xmpu
 * @date 2018年9月11日 下午7:53:37
 * 
 * @version v1.0
 */
@FeignClient(name = "qyzg-server")
@Component
public interface QyzgZgClient {

	/**
	 * 企业资格申请
	 * @param zg
	 * @param page
	 * @param size
	 * @return
	 */
	@RequestMapping(method = RequestMethod.POST, value = "/qyzgQyzgxx/findByPage/{page}/{size}")
	 ResponseWrapper findByPage(@RequestBody QyzgQyzgxxVO zg, @PathVariable("page") Integer page, @PathVariable("size") Integer size);

	/**
	 * 查询资格详情
	 * @param id
	 * @return
	 */
	@RequestMapping(method = RequestMethod.GET, value = "/qyzgQyzgxx/findById/{id}")
	ResponseWrapper findById(@PathVariable("id") String id);

	/**
	 * 撤销企业资格
	 */
	@RequestMapping(method = RequestMethod.POST, value = "/qyzgQyzgxx/cancelQualification")
	ResponseWrapper cancelQualification(@RequestBody QyzgQyzgxxVO zg);

}
