package com.unis.qyzg.common.vo;

import com.unis.common.utils.UUIDUtils;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Date;


/**
 * 基础实体类
 * 所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 *
 * @author Garfield
 */

/**
 * @ClassName BaseEntity
 * @Description 基础实体类，所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 * @Author tiechanglong
 * @Date 2019/7/22 17:07
 * @Version 0.0.3
 **/
@Getter
@Setter
public abstract class BaseVO {

    /**
     * id
     */
    private String id = UUIDUtils.uuid();

    /**
     * 状态，1：正常，0：已作废
     */
    private Integer status;

    /**
     * 地区编码
     */
    private String areaCode;

    /**
     * 创建人（申请人）
     */
    private String creator;

    /**
     * 创建人编码（申请人编码）
     */
    private String creatorCode;

    /**
     * 创建时间
     */
    private Date createDate;

    /**
     * 更新人
     */
    private String refersher;

    /**
     * 更新人编码
     */
    private String refersherCode;

    /**
     * 更新时间
     */
    private Date refersherDate;

    /**
     * 备注
     */
    private String remark;

    /**
     *  用户类型  10 粮食局用户  20 企业用户
     */
    private String userType;

    /**
     *  报表期
     */
    private String bbq;



}
