package com.unis.qyzg.common.vo;

import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiOperation;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.util.Date;
import java.util.List;

/**
 * 企业资格管理：资格申请 表
 */
@SuppressWarnings("serial")
@Getter
@Setter
@ToString
public class QyzgZgsqVO extends BaseVO{
    /**
     * 企业ID
     */
    private String qyId;
    /**
     * 企业名称
     */
    private String companyName;
    /**
     * 资格类型代码：1-承储资格（粮食类）；2-承储资格（食用植物油类）
     */
    private String zglxDm;
    /**
     * 资格申请类型：1-资格认证；2-资格变更；3-资格延续
     */
    private Integer zgsqlx;
    /**
     * 申请信息
     */
    private String sqxx;
    /**
     * 流程状态
     */
    private String lczt;
    /**
     * 申请状态：0-草稿；1-审批中；2-审批完成（通过）；3-审批完成（未通过）
     */
    private Integer sqzt;
    /**
     * 流程id
     */
    private String lcslId;
    /**
     * 用户名
     */
    private String account;
    /**
     * 机构名称
     */
    private String orgName;
    /**
     * 用户统一社会信用代码
     */
    private String userCreditCode;
    /**
     * 所属地区
     */
    private String qydq;
    /**
     * 企业名称
     */
    private String qyName;
    /**
     * 仓容
     */
    private String  kzzd1;
    /**
     * 模糊搜索企业信用代码
     */
    private String  kzzd2;
    /**
     * 扩展字段1
     */
    private String kzzd3;
    /**
     * 扩展字段1
     */
    private String kzzd4;
    /**
     * 扩展字段1
     */
    private String kzzd7;
    /**
     * 扩展字段1
     */
    private String kzzd5;
    /**
     * 扩展字段1
     */
    private String kzzd6;
    /**
     * 扩展字段1
     */
    private String kzzd8;
    /**
     * 扩展字段1
     */
    private String kzzd9;
    /**
     * 扩展字段1
     */
    private String kzzd10;
    //企业备案证书
    private QyzgBazsVO qyzgBazsVO;
    /**
     * 审批完成时间
     */
    private Date spwcsj;
    /**
     * 证书结束时间
     */
    private Date yxqjzsj;
    /**
     * 证书有效开始时间
     */
    private Date yxqkssj;
    /**
     * 资格证书编号
     */
    private String zgzbh;
    /**
     * 提交时间
     */
    private Date tjspsj;
    /**
     * 撤销原因
     */
    private String cxyy;
    /**
     * 撤销时间
     */
    private Date cxsj;
    /**
     * 撤销状态
     */
    private String undoState;

    @JsonFormat(pattern="yyyy-MM-dd")
    private Date startDate;

    @JsonFormat(pattern="yyyy-MM-dd")
    private Date endDate;

    /**
     * 文件ID
     */
    private String file1;
    private String file2;
    private String file3;
    private String file4;
    private String file5;
    private String file6;
    private String file7;
    private String file8;

    //待办任务集合
    List<DeploymentVO> deploymentVOs;
    
    //待办任务id集合
    List<String> lcids;
    
    //工作流启动需要的数据
    /**
     * 流程Key
     */
    private String processKey;
    private String statusKey;
    private String flowStatus;
    private String userType;
    private String bbq;
    private String userId;

}