package com.unis.qyzg.client;

import com.unis.common.utils.ResponseWrapper;
import io.swagger.annotations.ApiOperation;
import org.checkerframework.checker.units.qual.C;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Repository;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 *
 * @ClassName: DataDictClient
 * @Description: 数据字典
 * @version v1.0
 */
@FeignClient(name = "base-server")
@Repository
public interface DataDictClient {

    @RequestMapping(method = RequestMethod.GET, value = "/company/{tyshxydm}")
     ResponseWrapper getCompanyBytyshxydm(@PathVariable("tyshxydm") String tyshxydm);

    /**
     * 根据企业机构代码查询企业
     * @param qyjgdm
     * @return
     */
    @RequestMapping(method = RequestMethod.GET,  value = "/organization/{qyjgdm}")
     ResponseWrapper getSlqy(@PathVariable("qyjgdm") String qyjgdm);

}
