package com.unis.qyzg.entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;

import lombok.Getter;
import lombok.Setter;

import com.unis.common.utils.UUIDUtils;


/**
 * 基础实体类
 * 所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 *
 * @author Garfield
 */
/**
 * @ClassName BaseEntity
 * @Description 基础实体类，所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 * @Author tiechanglong
 * @Date 2019/7/22 17:07
 * @Version 0.0.3
 **/
@Getter
@Setter
@MappedSuperclass
public abstract class BaseEntity implements Serializable {
    private static final long serialVersionUID = -5082401234492420871L;

    @Id
    @Column(name="ID")
    private String id = UUIDUtils.uuid();

    /**
     * 状态，1：正常，0：已作废
     */
    @Column(name="STATUS")
    private Integer status;

    /**
     * 地区编码
     */
    @Column(name="AREA_CODE")
    private String areaCode;
    /**
     * 地区编码
     */
    @Column(name="AREA_NAME")
    private String areaName;

    /**
     * 创建人（申请人）
     */
    @Column(name="CREATOR")
    private String creator;

    /**
     * 创建人编码（申请人编码）
     */
    @Column(name="CREATOR_CODE")
    private String creatorCode;

    /**
     * 创建时间
     */
    @Column(name="CREATE_DATE")
    private Date createDate;

    /**
     * 更新人
     */
    @Column(name="REFERSHER")
    private String refersher;

    /**
     * 更新人编码
     */
    @Column(name="REFERSHER_CODE")
    private String refersherCode;

    /**
     * 更新时间
     */
    @Column(name="REFERSHER_DATE")
    private Date refersherDate;

    /**
     * 备注
     */
    @Column(name="REMARK")
    private String remark;



}
