package com.unis.qyzg.entity.father;

import com.unis.qyzg.common.vo.HistoryVO;
import com.unis.qyzg.common.vo.QyzgBazsVO;
import com.unis.qyzg.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import javax.persistence.Column;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * 企业资格管理：资格申请 表
 */
@SuppressWarnings("serial")
@Data
@ToString
@Table(name = "QYZG_ZGSQ")
public class QyzgZgsq extends BaseEntity {
    /**
     * 企业ID
     */
    @Column(name = "QY_ID")
    private String qyId;

    /**
     * 资格类型代码：1-承储资格（粮食类）；2-承储资格（食用植物油类）
     */
    @Column(name = "ZGLX_DM")
    private String zglxDm;

    /**
     * 资格申请类型：1-资格认证；2-资格变更；3-资格延续
     */
    @Column(name = "ZGSQLX")
    private Integer zgsqlx;

    /**
     * 提交时间
     */
    @Column(name = "TJSPSJ")
    private Date tjspsj;

    /**
     * 申请状态：申请状态:1.待提交 2.待审核 3.审核通过 4.驳回 5.备案已过期
     */
    @Column(name = "SQZT")
    private Integer sqzt;

    /**
     * 审批完成时间
     */
    @Column(name = "SPWCSJ")
    private Date spwcsj;

    /**
     * 申请信息
     */
    @Column(name = "SQXX")
    private String sqxx;

    /**
     * 流程实例ID
     */
    @Column(name = "LCSL_ID")
    private String lcslId;

    /**
     * 流程状态
     */
    @Column(name = "LCZT")
    private String lczt;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_1")
    private String kzzd1;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_2")
    private String kzzd2;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_3")
    private String kzzd3;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_4")
    private String kzzd4;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_7")
    private String kzzd7;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_5")
    private String kzzd5;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_6")
    private String kzzd6;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_8")
    private String kzzd8;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_9")
    private String kzzd9;

    /**
     * 扩展字段1
     */
    @Column(name = "KZZD_10")
    private String kzzd10;


    /**
     * 证书结束时间
     */
    @Transient
    private Date yxqjzsj;

    /**
     * 证书有效开始时间
     */
    @Transient
    private Date yxqkssj;

    /**
     * 资格证书编号
     */
    @Transient
    private String zgzbh;

    /**
     * 企业名称
     */
    @Transient
    private String qyName;
    /**
     * 企业地区
     */
    @Transient
    private String qydq;

    /**
     * 撤销原因
     */
    @Transient
    private String cxyy;
    /**
     * 撤销时间
     */
    @Transient
    private Date cxsj;

    /**
     * 撤销状态
     */
    @Transient
    private String undoState;
    /**
     * 撤销人code
     */
    @Transient
    private String zgcxrCode;

    /**
     * 撤销人
     */
    @Transient
    private String zgcxr;

    /**
     * 限期内是否可以再次申请：1-是；0--否';
     */
    @Transient
    private String xqnsfkzcsq;

    @ApiModelProperty("任务id")
    @Transient
    private String taskId;

    /**
     * 文件ID
     */
    @Column(name = "FILE_1")
    private String file1;
    @Column(name = "FILE_2")
    private String file2;
    @Column(name = "FILE_3")
    private String file3;
    @Column(name = "FILE_4")
    private String file4;
    @Column(name = "FILE_5")
    private String file5;
    @Column(name = "FILE_6")
    private String file6;
    @Column(name = "FILE_7")
    private String file7;
    @Column(name = "FILE_8")
    private String file8;

    @ApiModelProperty
    @Transient
    private Boolean flag;

    @ApiModelProperty
    @Transient
    private String taskName;

    @Transient
    private List<HistoryVO> historyVOs;

    //企业备案证书
    @Transient
    private QyzgBazsVO qyzgBazsVO;


}