package com.unis.qyzg.service;


import com.unis.common.utils.ResponseWrapper;
import com.unis.flowable.common.vo.DeploymentVO;
import com.unis.flowable.common.vo.ExamineVO;
import com.unis.flowable.common.vo.FlowAbleCompleteVO;
import com.unis.flowable.common.vo.FlowAbleStartVO;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/7/12 0012 14:30
 * @Description:
 */
public interface FlowAbleService {
    /**
     * 启动工作流
     * @param flowAbleStartVO
     * @return
     */
    FlowAbleCompleteVO start(FlowAbleStartVO flowAbleStartVO);

    /**
     * 查询待办个人任务和组任务合并列表---不分页
     * @param userId
     * @return
     */
    List<DeploymentVO> findByUserAndGroupTaskNoPage(String userId,String areaCode);


    /**
     * 审批
     * @param completeVO
     * @return
     */
    ResponseWrapper complete(FlowAbleCompleteVO completeVO);

    /**
     *  根据任务ID -- 查询办理任务明细
     * @param taskId
     * @param procInsId
     * @return
     */
    Map findByFormKeyByTaskId(String taskId, String procInsId);

    /**
     *工作流审批--通过，驳回
     * @param examineVO
     * @return
     */
    ResponseWrapper startExamine(ExamineVO examineVO);

    /**
     *  获取  下一个审核节点
     * @param completeVO
     */
    void getTaskAssignee(FlowAbleCompleteVO completeVO);

    /**
     * 查询已办理任务明细  和审核信息
     * @param taskId
     * @param procInsId
     * @return
     */
    Map findByAlreadyDone(String taskId, String procInsId);


    /**
     * 审批并且分配组任务
     * @param completeVO
     * @return
     */
    ResponseWrapper completeGroup(FlowAbleCompleteVO completeVO);

    /**
     * 拾取任务，将组任务分给个人任务
     * @param taskId 任务ID
     * @param userId 用户ID
     */
    ResponseWrapper claim(String taskId, String userId);


    /**
     * 询已办列表---不分页
     * @param userId
     * @return
     */
    ResponseWrapper findByAlreadyDoneoPage(String userId);

    /**
     * 生成流图 返回base64 编码
     * @param processId  流程ID
     * @return
     */
    ResponseWrapper findByLcslImage(String processId);

    /**
     * 根据流程ID查询审核记录
     * @param procInstId
     * @return
     */
    List<Map> findByProcessInfo(String procInstId);
    
    
    public String getStatus (String tyshxydm );
}