package com.unis.qyzg.service;

import com.unis.qyzg.common.vo.QyzgZgsqVO;
import com.unis.qyzg.entity.father.QyzgZgsq;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/7/25 0025 16:39
 * @Description:
 */
public interface QyzgZgsqService {

    /**
     * 更新草稿信息
     * @param qyzgZgsqVO
     * @return
     * @throws Exception
     */
     boolean updateQyzgZgsq(QyzgZgsqVO qyzgZgsqVO);

    /**
     * 保存----资格申请
     * @param qyzgZgsqVO
     * @return
     */
    String save(QyzgZgsqVO qyzgZgsqVO);

    /**
     * 修改申请状态----资格申请
     * @param qyzgZgsqVO
     * @return
     */
    QyzgZgsq updateSqzt(QyzgZgsqVO qyzgZgsqVO);

    /**
     * 查询企业资格详情
     * @param id
     * @return
     */
     QyzgZgsq findByid(String id);


    /**
     *根据流程ID查询详情
     * @param lcslId
     * @return
     */
    QyzgZgsq findByLcslId(String lcslId);

    /**
     *
     * @param areaCode
     * @return
     */
     List<QyzgZgsq> selectQyzgAreaCode(String areaCode);

    /**
     * 删除草稿
     * @param ids
     * @return
     * @throws Exception
     */
    boolean deletes(String [] ids);


    /**
     * 申请统计
     * @param zgVO
     * @param page
     * @param size
     * @return
     */
    Map<String, Object> provinceFindByPage(QyzgZgsqVO zgsqVO  , Integer page, Integer size);

    /**
     * 代办事项修改
     * @param qyzgZgsqVO
     * @return
     */
    boolean updateZgsq(QyzgZgsqVO qyzgZgsqVO);


    /**
     * 根据统一社会信用代码判断企业是否可以新申请备案
     * @param tyshxydm
     * @return
     */
    boolean isNewApply(String tyshxydm);

    /**
     * 功能描述: 备案填写---删除
     *
     * @Param: [id]
     * @Return: com.unis.common.utils.ResponseWrapper
     * @Author: zoujieli
     * @Date: 2020-02-28 16:16
     */
    void deleteRecordCertificate(String id);
}