package com.unis.qyzg.service.impl;

import com.alibaba.druid.sql.dialect.oracle.ast.clause.ModelClause.ReturnRowsClause;
import com.alibaba.fastjson.JSONObject;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.DateUtil;
import com.unis.common.utils.ResponseWrapper;
import com.unis.flowable.client.FlowAbleClient;
import com.unis.flowable.common.vo.*;
import com.unis.qyzg.client.DataDictClient;
import com.unis.qyzg.client.UserClient;
import com.unis.qyzg.common.vo.QyzgZgsqVO;
import com.unis.qyzg.entity.father.QyzgZgsq;
import com.unis.qyzg.service.FlowAbleService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @Auther:张新亮
 * @Date: 2019/7/12 0012 14:31
 * @Description:
 */
@Service
public class FlowAbleServiceImpl implements FlowAbleService {

    @Autowired
    private DataDictClient client;
    @Autowired
    private FlowAbleClient flowAbleClient;
    @Autowired
    private UserClient systemCenterClient;

    /**
     * 启动工作流  由企业用户或粮食局用户 来启动流程
     * @param flowAbleStartVO
     * @return
     */
    @Override
    public FlowAbleCompleteVO start(
            FlowAbleStartVO flowAbleStartVO
    ) {
    	
    	
    	
    	
        //用户类型  10 粮食局用户  20 企业用户
        if("20".equals(flowAbleStartVO.getUserType())){
            //流程 key 启动工作流 获取 流程 key
            ResponseWrapper  responseWrapper=getStartProcessId(flowAbleStartVO);
            //启动工作流 -- 200 成功
            if(responseWrapper.getInfoCode()==200) try {
                {
                    Map  map= (Map) responseWrapper.getData();
                    String processId=map.get("processId").toString();
                    FlowAbleCompleteVO completeVO=new FlowAbleCompleteVO();
                    completeVO.setProcessId(processId);
                    completeVO.setUserId(flowAbleStartVO.getUserId());
                    completeVO.setUserType(flowAbleStartVO.getUserType());
                    completeVO.setUserName(flowAbleStartVO.getOrgName());
                    completeVO.setMessage("提交申请");
                    completeVO.setEvent("提交");
                    //使用 添加变量
                    setVariableByTask(flowAbleStartVO,processId);
                    //如果是企业则默认 进行审核提交申请
                    ResponseWrapper responseWrapper1=this.defaultComplete(completeVO);
                    if(responseWrapper1.getInfoCode()==200){
                        return completeVO;
                    }else{
                        return null;
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return null;
    }




    /**
     * 使用 添加变量
     * @param flowAbleStartVO
     */
    private ResponseWrapper setVariableByTask(FlowAbleStartVO flowAbleStartVO, String processId) {

        Map map=new HashMap();
        /**
         *  报表期
         */
        map.put("bbq",flowAbleStartVO.getBbq());
        /**
         * 用户名
         */
        map.put("userName", flowAbleStartVO.getAccount());
        /**
         * 用户统一社会信用代码
         */
        map.put("userCreditCode", flowAbleStartVO.getCreditCode());
        /**
         * 机构名称
         */
        map.put("orgName", flowAbleStartVO.getOrgName());
        /**
         * 发起时间
         */
        String startTime= DateUtil.getDateFormat(new Date(), DateUtil.df);
        map.put("startTime", startTime);


        /**
         * 行政区划
         */
        if("150000".equals(flowAbleStartVO.getAreaCode())){
            map.put("areaCode",flowAbleStartVO.getAreaCode());
        }else{
            boolean status = flowAbleStartVO.getAreaCode().contains("00");
            //true  市用户  false 县用户
            if(status){
                map.put("areaCode", flowAbleStartVO.getAreaCode() + ",150000");
            }else{
                String shiCode=flowAbleStartVO.getAreaCode().substring(0, 4)+"00";
                map.put("areaCode", flowAbleStartVO.getAreaCode()+","+shiCode+",150000");
            }
        }


        //Map 转成  JSONObject 字符串
        JSONObject jsonObj=new JSONObject(map);

        String values=jsonObj.toString();

       return flowAbleClient.setVariableByTask(values, processId);
    }


    /**
     * 启动工作流 成功后运回 key
     * @param flowAbleStartVO
     * @return
     */
    private ResponseWrapper getStartProcessId(
            FlowAbleStartVO flowAbleStartVO
    ) {

        StartNewTaskVO startNewTaskVO=new StartNewTaskVO();
        /**
         * 流程key
         */
        String processKey=flowAbleStartVO.getProcessKey();
        startNewTaskVO.setProcessKey(processKey);
        /**
         * 数据id
         */
        String id=flowAbleStartVO.getId();
        startNewTaskVO.setId(id);
        /**
         * 标识流程状态传参key
         */
        String statusKey=flowAbleStartVO.getStatusKey();
        startNewTaskVO.setStatusKey(statusKey);
        /**
         * 流程状态status
         */
        String status=flowAbleStartVO.getStatus();
        startNewTaskVO.setStatus(status);
        /**
         * 用户ID
         */
        String userId=flowAbleStartVO.getUserId();
        startNewTaskVO.setUserId(userId);
        System.out.println("==========================启动工作流参数 start=============================");
        System.out.println(startNewTaskVO.toString());
        System.out.println("==========================启动工作流参数 end=============================");
        ResponseWrapper responseWrapper=flowAbleClient.start(startNewTaskVO);
        return responseWrapper;

    }



    /** 标识流程状态传参key  标识流程状态传参key
     * status :
     * 0: 启动流程当前用户默认传值
     * 1 上集集团用户
     * 2 县粮食局用户
     * 3 市粮食局用户
     * 4 省粮食局用户
     * comeout :
     * 1 通过
     * 2 驳回
     * 企业默认审核
     * @param completeVO
     * @return
     */
    private ResponseWrapper defaultComplete(FlowAbleCompleteVO completeVO) {
        // 下级审批用户id，多个以逗号隔开  和status 状态
        getTaskAssignee(completeVO);
        completeVO.setComeoutKey("comeoutKey");
        System.out.println("=====================企业默认审核 start ==============================");
        System.out.println(completeVO.toString());
        System.out.println("=====================企业默认审核 end ==============================");
        return  flowAbleClient.complete(completeVO);


    }


    /**
     * 查询待办个人任务和组任务合并列表---不分页
     * @param userId
     * @return
     */
    @Override
    public List<DeploymentVO> findByUserAndGroupTaskNoPage(String userId,String areaCode) {
        List<DeploymentVO> deploymentLists=new ArrayList();
        ResponseWrapper responseWrapper=flowAbleClient.findByUserAndGroupTaskNoPage(userId, areaCode);
        if(responseWrapper.getInfoCode()==200){
            deploymentLists= (List<DeploymentVO>) responseWrapper.getData();
        }
        return deploymentLists;
    }









    /**
     * 审核
     * @param completeVO
     * @return
     */
    @Override
    public ResponseWrapper complete(FlowAbleCompleteVO completeVO) {
        ResponseWrapper responseWrapper= flowAbleClient.complete(completeVO);
        return responseWrapper ;
    }




    /**
     * 审核
     * @param completeVO
     * @return
     */
    @Override
    public ResponseWrapper completeGroup(FlowAbleCompleteVO completeVO) {
        CompleteGroupVO completeGroupVO=new CompleteGroupVO();
        //流程id
        String processId=completeVO.getProcessId();
        completeGroupVO.setProcessId(processId);
        //用户id
        String userId=completeVO.getUserId();
        completeGroupVO.setUserId(userId);
        //流程状态传参key
        String statusKey=completeVO.getStatusKey();
        completeGroupVO.setStatusKey(statusKey);
        //流程状态传参value
        String status=completeVO.getStatus();
        completeGroupVO.setStatus(status);
        //审批建议
        String message=completeVO.getMessage();
        completeGroupVO.setMessage(message);
        // 驳回key
        String comeoutKey=completeVO.getComeoutKey();
        completeGroupVO.setComeoutKey(comeoutKey);
        //驳回value
        String comeout=completeVO.getComeout();
        completeGroupVO.setComeout(comeout);
        //事件方法
        completeGroupVO.setUserName(completeVO.getUserName());
        completeGroupVO.setEvent(completeVO.getEvent());
        ResponseWrapper responseWrapper= flowAbleClient.completeGroup(completeGroupVO);
        return  responseWrapper ;
    }




    /**
     *  获取  下一个审核节点
     * @param completeVO
     */
    @Override
    public void getTaskAssignee(FlowAbleCompleteVO completeVO) {
        //当前用户是否是企业用户
        if("20".equals(completeVO.getUserType())){
            String orgId= completeVO.getUserId();
            //判断企业是否有 上集集团  如果有 获取上集团的 统一社会信用户代码,如果没有则获取 当前用户的直属粮食局用户
            ResponseWrapper responseWrapper=client.getCompanyBytyshxydm(orgId);
            Map map= (Map) responseWrapper.getData();
                String assignee=map.get("sjjttyshxydm")==null?"":map.get("sjjttyshxydm").toString();
                //ifjt  是否集团  0  不是  1 是
                completeVO.setStatusKey("status");
                if(!"".equals(assignee) && assignee!=null){
                    completeVO.setAssignee(assignee);
                    completeVO.setStatus("1");
            }else{
                //  省級   LS001
                //省用户
                    assignee=map.get("qyszqybh")==null?"":map.get("qyszqybh").toString();
                if(assignee.contains("0000")){
                    completeVO.setStatus("4");
                }else{
                    boolean status = assignee.contains("00");
                    //true  市用户  false 县用户
                    if(status) {
                        completeVO.setStatus("3");
                    } else {
                        completeVO.setStatus("2");
                    }
                }
            }
        }

        if("10".equals(completeVO.getUserType())){
            String areaCode=completeVO.getAreaCode();
            completeVO.setStatusKey("status");
            //省用户
            if(areaCode.contains("0000")){
                //如果是当前用户是省级用户则审核节点节结束
                completeVO.setStatus("6");
            }else{
                boolean status = areaCode.contains("00");
                //true  市用户  false 县用户
                if(status) {
                    //如果当前用户是市用户 则下一个节点是 省用户
//                    completeVO.setAssignee("530000");
                    completeVO.setStatus("4");
                } else {
                    // 如果当前用户是县用户，则下一下节点是 市用户
//                    completeVO.setAssignee( assignee.substring(0,4)+"00");
                    completeVO.setStatus("3");
                }
            }
        }

    }

    /**
     * 查询已办理任务明细  和审核信息
     * @param taskId
     * @param procInsId
     * @return
     */
    @Override
    public Map findByAlreadyDone(String taskId, String procInsId) {
        String name="";
        ResponseWrapper responseWrapper=flowAbleClient.findByAlreadyDone(taskId, procInsId);
        if(responseWrapper.getInfoCode()==200){
            Map map=(Map) responseWrapper.getData();
            List<Map> commentList= (List<Map>) map.get("commentList");
            for(Map coMap:commentList){
                String userType=coMap.get("userType").toString();
                String assigneeName=coMap.get("assigneeName").toString();
                if("yes".equals(userType)){
                    assigneeName= getAssigneeName(assigneeName);
                    coMap.put("assigneeName",assigneeName);
                }
            }
            map.put("commentList",commentList);
            return map;
        }else{
            return null;
        }
    }


    /**
     *  根据任务ID -- 查询办理任务明细
     * @param taskId
     * @param procInsId
     * @return
     */
    @Override
    public Map findByFormKeyByTaskId(String taskId, String procInsId) {
        String name="";
        ResponseWrapper responseWrapper=flowAbleClient.findByFormKeyByTaskId(taskId, procInsId);
        if(responseWrapper.getInfoCode()==200){
            Map resultMap=(Map) responseWrapper.getData();
            List<Map> commentList= (List<Map>) resultMap.get("commentList");
            List<Map> buttonList= (List<Map>) resultMap.get("buttonList");
            for(Map coMap:commentList){
                String userType=coMap.get("userType").toString();
                String assigneeName=coMap.get("assigneeName").toString();
                if("yes".equals(userType)){
                    assigneeName= getAssigneeName(assigneeName);
                    coMap.put("assigneeName",assigneeName);
                }
            }
            resultMap.put("commentList",commentList);

            //获取按钮
            if(buttonList.size()>=2){
                List<Map> mapList=new ArrayList();
                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("通过".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }
                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("不通过".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }

                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("受理".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }

                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("不受理".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }

                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("打回修改".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }

                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("驳回".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }
                resultMap.put("buttonList",mapList);
            }else{
                List<Map> mapList=new ArrayList();
                for(Map map: buttonList){
                    String button=map.get("button").toString();
                    if("提交".equals(button)){
                        map.put("sgin",false);
                        mapList.add(map);
                    }
                }
                resultMap.put("buttonList",mapList);
            }
            return resultMap;
        }else{
            return null;
        }
    }


    /**
     * 审核驳回接口
     * @param examineVO
     * @return
     */
    @Override
    public ResponseWrapper startExamine(ExamineVO examineVO) {
        FlowAbleCompleteVO flowAbleCompleteVO=new FlowAbleCompleteVO();
        // 流程ID
        flowAbleCompleteVO.setProcessId(examineVO.getProcInstId());
        //用户类型
        flowAbleCompleteVO.setUserType(examineVO.getUserType());
        //当前任务办理人
        flowAbleCompleteVO.setUserId(examineVO.getUserId());
        //行政区划
        flowAbleCompleteVO.setAreaCode(examineVO.getAreaCode());
        flowAbleCompleteVO.setUserName(examineVO.getUserName());
        flowAbleCompleteVO.setEvent(examineVO.getStatus());

        if("提交".equals(examineVO.getStatus())){
            //审批建议
            submission(flowAbleCompleteVO,examineVO);
        }

        if("打回修改".equals(examineVO.getStatus())){
            reject(flowAbleCompleteVO, examineVO);
        }
        if("通过".equals(examineVO.getStatus())){
            pass(flowAbleCompleteVO, examineVO);
        }
        if("不通过".equals(examineVO.getStatus())){
            noPass(flowAbleCompleteVO, examineVO);
        }

        if("受理".equals(examineVO.getStatus())){
            acceptance(flowAbleCompleteVO, examineVO);
        }

        if("不受理".equals(examineVO.getStatus())){
            noAcceptance(flowAbleCompleteVO, examineVO);
        }



        System.out.println("=================提交工作流程 start=========================");
        System.out.println(flowAbleCompleteVO.toString());
        System.out.println("=================提交工作流程 end=========================");


        //下一个节点为上集集团  走个人任务
        if("1".equals(flowAbleCompleteVO.getStatus())
                || "10".equals(flowAbleCompleteVO.getStatus())
                || "7".equals(flowAbleCompleteVO.getStatus())
        ){
            return this.complete(flowAbleCompleteVO);
        }else{
            //下一节点为后台管理用户 --走组任务
            return this.completeGroup(flowAbleCompleteVO);
        }
    }

    /**
     * 不受理
     * @param flowAbleCompleteVO
     * @param examineVO
     */
    private void noAcceptance(
            FlowAbleCompleteVO flowAbleCompleteVO,
            ExamineVO examineVO
    ) {
        flowAbleCompleteVO.setComeoutKey("comeout");
        flowAbleCompleteVO.setComeout("20");
        //审批建议
        if(StringUtils.isEmpty(examineVO.getNode())){
            flowAbleCompleteVO.setMessage("不受理");
        }else {
            flowAbleCompleteVO.setMessage(examineVO.getNode());
        }
        flowAbleCompleteVO.setStatus("7");
        flowAbleCompleteVO.setStatusKey("status");
    }



    /**
     * 不通过
     * @param flowAbleCompleteVO
     * @param examineVO
     */
    private void noPass(
            FlowAbleCompleteVO flowAbleCompleteVO,
            ExamineVO examineVO
    ) {
        flowAbleCompleteVO.setComeoutKey("comeout");
        flowAbleCompleteVO.setComeout("20");
        //审批建议
        if(StringUtils.isEmpty(examineVO.getNode())){
            flowAbleCompleteVO.setMessage("不通过");
        }else {
            flowAbleCompleteVO.setMessage(examineVO.getNode());
        }
        flowAbleCompleteVO.setStatus("7");
        flowAbleCompleteVO.setStatusKey("status");
    }



    /**
     * 受理
     * @param flowAbleCompleteVO
     * @param examineVO
     */
    private void acceptance(
            FlowAbleCompleteVO flowAbleCompleteVO,
            ExamineVO examineVO
    ) {
        flowAbleCompleteVO.setComeoutKey("comeout");
        flowAbleCompleteVO.setComeout("20");
        //审批建议
        if(StringUtils.isEmpty(examineVO.getNode())){
            flowAbleCompleteVO.setMessage("受理");
        }else {
            flowAbleCompleteVO.setMessage(examineVO.getNode());
        }
        flowAbleCompleteVO.setStatus("5");
        flowAbleCompleteVO.setStatusKey("status");

    }

    /**
     * 通过
     * @param flowAbleCompleteVO
     * @param examineVO
     */
    private void pass(
            FlowAbleCompleteVO flowAbleCompleteVO,
            ExamineVO examineVO
    ) {
        flowAbleCompleteVO.setComeoutKey("comeout");
        flowAbleCompleteVO.setComeout("20");
        //审批建议
        if(StringUtils.isEmpty(examineVO.getNode())){
            flowAbleCompleteVO.setMessage("通过");
        }else {
            flowAbleCompleteVO.setMessage(examineVO.getNode());
        }
        // 下级审批用户id，多个以逗号隔开  和status 状态
        getTaskAssignee(flowAbleCompleteVO);
    }

    /**
     * 提交
     * @param flowAbleCompleteVO
     * @param examineVO
     */
    private void submission(
            FlowAbleCompleteVO flowAbleCompleteVO,
            ExamineVO examineVO
    ) {

        if(StringUtils.isEmpty(examineVO.getNode())){
            flowAbleCompleteVO.setMessage("提交");
        }else {
            flowAbleCompleteVO.setMessage(examineVO.getNode());
        }
        flowAbleCompleteVO.setComeoutKey("coutout");
        flowAbleCompleteVO.setComeout("100");

        //获取提交数据
        getSubmission(flowAbleCompleteVO);
    }


    /**
     * 获取驳回数据
     * @param flowAbleCompleteVO
     * @param examineVO
     */
    private void reject(
            FlowAbleCompleteVO flowAbleCompleteVO,
            ExamineVO examineVO
    ) {
        flowAbleCompleteVO.setComeoutKey("status");
        flowAbleCompleteVO.setComeout("0");
        //审批建议
        if(StringUtils.isEmpty(examineVO.getNode())){
            flowAbleCompleteVO.setMessage("驳回");
        }else {
            flowAbleCompleteVO.setMessage(examineVO.getNode());
        }

        //流程状态传参key
        String statusKey="comeout";
        //流程状态传参value
        String status="10";
        flowAbleCompleteVO.setStatusKey(statusKey);
        flowAbleCompleteVO.setStatus(status);
        flowAbleCompleteVO.setAssignee(examineVO.getUserCreditCode());
    }

    /**
     * 获取提交数据
     * @param flowAbleCompleteVO
     * @return
     */
    private void getSubmission(FlowAbleCompleteVO flowAbleCompleteVO) {
        getTaskAssignee(flowAbleCompleteVO);
    }


    /**
     * 拾取任务，将组任务分给个人任务
     * @param taskId 任务ID
     * @param userId 用户ID
     * @return
     */
    @Override
    public ResponseWrapper claim(
            String taskId,
            String userId
    ) {
        ResponseWrapper responseWrapper=flowAbleClient.claim(taskId, userId);
        return responseWrapper;
    }

    /**
     * 查询已办列表---不分页
     * @param userId
     * @return
     */
    @Override
    public ResponseWrapper findByAlreadyDoneoPage(String userId) {
        return flowAbleClient.findByAlreadyDoneoPage(userId);
    }

    /**
     * 生成流图 返回base64 编码
     * @param processId  流程ID
     * @return
     */
    @Override
    public ResponseWrapper findByLcslImage(String processId) {
        return flowAbleClient.findByLcslImage(processId);
    }

    /**
     * 根据流程ID查询审核记录
     * @param procInstId
     * @return
     */
    @Override
    public List<Map> findByProcessInfo(String procInstId) {
        List<Map> mapList=new ArrayList();
        ResponseWrapper responseWrapper=flowAbleClient.findByProcessInfo(procInstId);
        if(responseWrapper.getInfoCode()==200){
        	Object obj = responseWrapper.getData();
            List parseObject = JSONObject.parseObject(JSONObject.toJSONString(obj), List.class);
            mapList = JSONObject.parseArray(JSONObject.toJSONString(parseObject), Map.class);
            for(Map map:mapList){
                String userType=map.get("userType").toString();
                String assigneeName=map.get("assigneeName").toString();
                if("yes".equals(userType)){
                    assigneeName=getAssigneeName(assigneeName);
                    map.put("assigneeName",assigneeName);
                }
            }
        }
        return mapList;
    }

    /**
     * 转用户名
     * @param assigneeName
     * @return
     */
    private String getAssigneeName(String assigneeName) {
        String name="";
        //查询管理端用户
        //ResponseWrapper warp=systemCenterClient.getAllUser(assigneeName);
        String[] assignee=assigneeName.split(",");
        ResponseWrapper warp=systemCenterClient.findByCode(assignee);
        if(warp.getInfoCode()==200){
        	
        	Object obj = warp.getData();
        	if(obj!=null&&!obj.toString().isEmpty()) {
        	
            List parseObject = JSONObject.parseObject(JSONObject.toJSONString(obj), List.class);
            List<Map> map1 = JSONObject.parseArray(JSONObject.toJSONString(parseObject), Map.class);
            name=map1.get(0).get("userName").toString();
            return name;
        	}
        }
        //查询企业端用户
        //ResponseWrapper responseWrapper=client.getSlqy(assigneeName);
        ResponseWrapper responseWrapper=client.getCompanyBytyshxydm(assigneeName);
        if(responseWrapper.getInfoCode()==200){
           Object data = responseWrapper.getData();
           
           if(data!=null&&!data.toString().isEmpty()) {
           Map map1 = JSONObject.parseObject(JSONObject.toJSONString(data), Map.class);
            name=map1.get("qymc").toString();
            return name;
           }
        }
        return null;
    }
    
    

    public String getStatus (String tyshxydm ) {
        //当前用户是否是企业用户
      
         
            //判断企业是否有 上集集团  如果有 获取上集团的 统一社会信用户代码,如果没有则获取 当前用户的直属粮食局用户
            ResponseWrapper responseWrapper=client.getCompanyBytyshxydm(tyshxydm);
            
            Map  map= (Map) responseWrapper.getData();
              
                   String assignee=map.get("qyszqybh")==null?"":map.get("qyszqybh").toString();
                if(assignee.contains("0000")){
                   return "4";
                }else{
                    boolean status = assignee.contains("00");
                    //true  市用户  false 县用户
                    if(status) {
                       return "3";
                    } else {
                       return "2";
                    }
                }
            }
       


}